//
//  CastSessionManager.m
// 
//
//  Created by Srikanth Atmakuri on 18/03/20.
//  Copyright © 2020 Google. All rights reserved.
//

#import "CastSessionManager.h"



@implementation CastSessionManager

GCKSession *session;
GCKSessionManager *_sessionManager;
KMA_Chromecast_Channel *KCC ;


/**
* returns CastSessionManager Instance
*/

-(CastSessionManager*)init{
    _sessionManager = [GCKCastContext sharedInstance].sessionManager;
    KCC = [[KMA_Chromecast_Channel alloc] initWithNamespace:@"urn:x-cast:com.de.spring.jschromecast"];
   
    return self;
}


/**
* Checks if active cast session is running or not
*/

-(BOOL) isCastingEnabled{
    BOOL hasConnectedSession = (_sessionManager.hasConnectedSession);
    if(hasConnectedSession){
        
        session = _sessionManager.currentSession;
        NSLog(@"%@", session.device.deviceID);
        //NSLog(session.device.deviceID);
        if(session && session.connectionState==GCKConnectionStateConnected){
            return YES;
        }
    }
    
    return NO;
}



-(void) sendMessage{
    if([self isCastingEnabled]){
        
        BOOL hasConnectedSession = (_sessionManager.hasConnectedSession);
        if(hasConnectedSession){
            session = _sessionManager.currentSession;
        GCKCastSession *ses = _sessionManager.currentSession;
        [ses addChannel:KCC];
            NSString *data= [NSString stringWithFormat:@"%@%@%@",@"{\"id\":\"",session.device.deviceID,@"\"}"];
        [KCC sendTextMessage:data error:nil];
        }
    }
}


@end
